﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GS.Unitive.Framework.Core;
using System.IO;
using SpeechLib;
using System.Speech.Synthesis;
using System.Threading.Tasks;

namespace GS.Terminal.Speak
{
    public class Activator : IAddonActivator
    {
        public static IAddonContext AddContext;
        private static int speakRate = 1;
        internal static NAudioPlayer AudioPlayer;
        public void Start(IAddonContext Context)
        {
            AddContext = Context;
            var configRate = AddContext.DictionaryValue("baseConfig", "VoiceSpeed");
            if (!int.TryParse(configRate, out speakRate))
            {
                speakRate = 1;
            }
            AudioPlayer = new NAudioPlayer();
        }

        public void Stop(IAddonContext Context)
        {
            AddContext = null;
        }
        static SpeechSynthesizer speak = null;
        /// <summary>
        /// 异步播放文本语音
        /// </summary>
        /// <param name="SpeakMessage"></param>
        internal static void Voice(string SpeakMessage)
        {
            if (speak == null)
            {
                try
                {
                    speak = new SpeechSynthesizer() { Volume = 100, Rate = speakRate };
                }
                catch (Exception ex)
                {
                    AddContext.Logger.Error($"语音播报模块加载异常,请安装ScanSoft_MeiLing_ChineseMandarinVoice", ex);
                    return;
                }
            }

            if (!string.IsNullOrEmpty(SpeakMessage))
            {
                speak.Speak(SpeakMessage);
            }
        }
    }
}
